/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define MAX_ADMINS	64

new admin_password[MAX_ADMINS][32]
new admin_name[MAX_ADMINS][32]
new admin_flags[MAX_ADMINS]
new admin_priv[MAX_ADMINS]
new admin_num = 0

new logfilename[256]

public admin_cmd(){
	if (admin_num >= MAX_ADMINS){
		server_print("Admins limit reached!")
		return PLUGIN_HANDLED
	}
	new data[32]
	read_argv(1,admin_name[admin_num],31)
	read_argv(2,admin_password[admin_num],31)
	read_argv(3,data,31)
	admin_priv[admin_num] = read_flags(data)
	read_argv(4,data,31)
	admin_flags[admin_num] = read_flags(data)
	admin_num++
	return PLUGIN_HANDLED
}

get_access(id,name[],authid[],ip[], password[]){
	new index = -1
	new result = 0
	for(new i = 0; i < admin_num; ++i) {
		if (admin_flags[i] & FLAG_AUTHID) {
			if (equal(authid,admin_name[i])) {
				index = i
				break
			}
		}
		else if (admin_flags[i] & FLAG_IP) {
			if (contain(ip,admin_name[i])!=-1){
				index = i
				break
			}
		}
		else {
			if (admin_flags[i] & FLAG_TAG)	{
				if (contain(name,admin_name[i])!=-1){
					index = i
					break
				}
			}
			else if (equal(name,admin_name[i])) {
				index = i
				break
			}
		}
	}
	if (index != -1) {
		if (admin_flags[index] & FLAG_NOPASS){
			result |= 8
			new sflags[32]
			get_flags(admin_priv[index],sflags,31)
			set_user_flags(id,admin_priv[index])
			log_to_file(logfilename,"Login: ^"%s<%d><%s><>^" become an admin (account ^"%s^") (access ^"%s^") (address ^"%s^")",
				name,get_user_userid(id),authid,admin_name[index] ,sflags,ip)
		}
		else if (equal(password,admin_password[index])) {
			result |= 12
			set_user_flags(id,admin_priv[index])
			new sflags[32]
			get_flags(admin_priv[index],sflags,31)
			log_to_file(logfilename,"Login: ^"%s<%d><%s><>^" become an admin (account ^"%s^") (access ^"%s^") (address ^"%s^")",
				name,get_user_userid(id),authid,admin_name[index] ,sflags,ip)
		}
		else {
			result |= 1
			if (admin_flags[index] & FLAG_KICK){
				result |= 2
				log_to_file(logfilename,"Login: ^"%s<%d><%s><>^" kicked due to invalid password (account ^"%s^") (address ^"%s^")",
					name,get_user_userid(id),authid,admin_name[index],ip)
			}
		}
	}
	else if (get_cvar_float("amx_mode")==2.0) {
		result |= 2
	}
	else {
		new defaccess[32]
		get_cvar_string("amx_default_access",defaccess,31)
		new idefaccess = read_flags(defaccess)
		if (idefaccess){
			result |= 8
			set_user_flags(id,idefaccess)
		}
  } 	
	
	return result
}

access_user(id,username[32]){ 
	new userip[32],userauthid[32],password[32],passfield[32] 
	get_user_ip(id,userip,31) 
	get_user_authid(id,userauthid,31) 
	get_cvar_string("amx_password_field",passfield,31) 
	get_user_info(id,passfield,password,31) 
	new result = get_access(id,username,userauthid,userip,password) 
	if (result & 1) client_cmd(id,"echo * Invalid Password!") 
	if (result & 2) { 
		client_cmd(id,"echo * You have no entry to the server...;disconnect") 
		return PLUGIN_HANDLED 
	}
	if (result & 4) client_cmd(id,"echo * Password accepted") 
	if (result & 8) client_cmd(id,"echo * Privileges set") 
	return PLUGIN_CONTINUE 
}

public client_infochanged(id){ 
	new newname[32], oldname[32] 
	get_user_name(id,oldname,31) 
	get_user_info(id,"name",newname,31) 
	if (is_user_connected(id)&&!equal(newname,oldname)){ 
		remove_user_flags(id) 
		access_user(id,newname)
	} 
	return PLUGIN_CONTINUE 
}

public client_connect(id){
	if (!get_cvar_float("amx_mode")) 
		return PLUGIN_CONTINUE
	remove_user_flags(id)       
	new name[32] 
	get_user_name(id,name,31) 
	return access_user(id,name)
}

public plugin_init(){
	register_plugin("Admin Base","0.9.3","default")
	register_srvcmd("amx_admin","admin_cmd")
	register_cvar("amx_mode","2.0")
	register_cvar("amx_password_field","_pw")
	register_cvar("amx_default_access","") 
	server_cmd("exec addons/amx/admin.cfg")
	remove_user_flags(0,read_flags("z")) /* remove 'user' flag from server rights */
	get_time("addons/amx/logs/admin%m%d.log",logfilename,255)
	return PLUGIN_CONTINUE
}
