/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

/*  
*  Server cmd:
*  amx_avlist_mode <flags>
*  "a" - shows attackers
*  "b" - shows victims
*  "c" - shows killer
*  "d" - displays player stats at the end of map
*  "e" - displays top15 at the end of map
*  "f" - displays killer hp&ap to victim console and screen
*  "g" - allow for say /hp
*  "h" - allow for say /stats
*  "i" - allow for say /top15
*  "j" - allow for say /rank
*  "k" - allow for say /statsme
*
*  Plugin works with Stats Settings Plugin. Just run both of them.
*  And via amx_statscfg command (from Stats Settings Plugin)
*  you will be able to set all settings and save them to a file.
*/

#include <amxmod>
#include <amxmisc>
#include <csstats>

#define STS_CHNL 	5

#define STS_FLAG2 2 //shows attackers
#define STS_FLAG3 3 //shows victims
#define STS_FLAG4 4 //shows killer
#define STS_FLAG5 5 //displays player stats at the end of map
#define STS_FLAG6 6 //displays top15 at the end of map
#define STS_FLAG7 7 //displays killer hp&ap to victim console and screen

// Say commands
#define STS_FLAG8 8 //displays information about user killer
#define STS_FLAG9 9 //displays players stats and rank
#define STS_FLAG10 10 //displays first 15. players
#define STS_FLAG11 11 //displays user position in rank
#define STS_FLAG12 12 //displays user stats

new killers[33][4]
new klist[33]
new buffor[2048]
new user_position[33]
new bool:user_state[33]
new user_players[33][32]
new body_part[8][] = {"whole body","head","chest","stomach","left arm","right arm","left leg","right leg"}

/* build list of attackers */
get_attackers(id) {
	new name[32],wpn[32], stats[8],body[8],found=0
	new pos = copy(buffor,2047,"Attackers:^n")
	new amax = get_maxplayers()
	for(new a = 1; a <= amax; ++a){
		if(get_user_astats(id,a,stats,body,wpn,31)){
			found = 1
			if (stats[0])
				format(wpn,31," -- %s",wpn)
			else
				wpn[0] = 0
			get_user_name(a,name,31)
			pos += format(buffor[pos],2047-pos,"%s -- %d dmg / %d hit(s)%s^n",name,stats[6],stats[5],wpn)
		}
	}
	return found
}

/* build list of victims */
get_victims(id) {
	new name[32],wpn[32], stats[8],body[8],found=0
	new pos = copy(buffor,2047,"Victims:^n")
	new amax = get_maxplayers()
	for(new a = 1; a <= amax; ++a){
		if(get_user_vstats(id,a,stats,body,wpn,31)){
			found = 1
			if (stats[1])
				format(wpn,31," -- %s",wpn)
			else
				wpn[0] = 0
			get_user_name(a,name,31)
			pos += format(buffor[pos],2047-pos,"%s -- %d dmg / %d hit(s)%s^n",name,stats[6],stats[5],wpn)
		}
	}
	return found
}

/* build list of hita for AV List */
get_hits(id,killer) {
	new stats[8], body[8], pos = 0
	buffor[0] = 0
	get_user_astats(id,killer,stats,body)
	for(new a = 1; a < 8; ++a)
		if(body[a])
			pos += format(buffor[pos],2047-pos,"%s: %d^n",body_part[a],body[a])
}

/* get top 15 */
get_top15(){
	new stats[8], body[8], name[32]
	new pos = copy(buffor,2047,"#   nick                           kills/deaths          hits/shots/headshots^n")
	new imax = get_statsnum()
	if (imax > 15) imax = 15
	for(new a = 0; a < imax; ++a){
		get_stats(a,stats,body,name,31)
		pos += format(buffor[pos],2047-pos,"%2d.  %-28.27s    %d/%d                      %d/%d/%d^n",a+1,name,stats[0],stats[1],stats[5],stats[4],stats[2])
	}
}

/* build list of hits for say hp */
get_myhits(id,killed) {
	new name[32], stats[8], body[8], found = 0
	get_user_name(killed,name,31)
	new pos = format(buffor,2047,"* You hit %s in:",name)
	get_user_vstats(id,killed,stats,body)
	for(new a = 1; a < 8; ++a){
		if(body[a]){
			found = 1
			pos += format(buffor[pos],2047-pos," %s: %d ",body_part[a],body[a])
		}
	}
	return found
}

/* save hits and damage */
public damage_event(id) {
	if (killers[id][0]) {
		klist[id] = 0
		new mode = get_user_flags(0,STS_CHNL)
		if ( mode & (1<<STS_FLAG4) ){
			new name[32], stats[8], body[8], wpn[33], mstats[8], mbody[8]
			get_user_name(killers[id][0],name,31)
			get_user_astats(id,killers[id][0],stats,body,wpn,31)
			get_user_vstats(id,killers[id][0],mstats,mbody)
			set_hudmessage(220,80,0,0.05,0.15,0, 6.0, 12.0, 1.0, 2.0, 1)
			get_hits(id,killers[id][0])
			show_hudmessage(id,"%s killed you with %s^nfrom distance of %.2f meters.^nHe did %d damage to you with %d hit(s)^nand still has %dhp and %dap.^nYou did %d damage to him with %d hit(s).^nHe hits you in:^n%s",
					name,wpn,float(killers[id][3]) * 0.0254,	stats[6],stats[5],		killers[id][1],killers[id][2],
						mstats[6],mstats[5],buffor )
		}
		if ( (mode&(1<<STS_FLAG3)) &&get_victims(id)){
			set_hudmessage(0,80,220,0.55,0.60,0, 6.0, 12.0, 1.0, 2.0, 4)
			show_hudmessage(id,buffor)
		}
		if ( (mode&(1<<STS_FLAG2)) &&get_attackers(id)){
			set_hudmessage(220,80,0,0.55,0.35,0, 6.0, 12.0, 1.0, 2.0, 3)
			show_hudmessage(id,buffor)
		}
	}
}

/* save state at death */
public deathmsg_event() {
	new killer = read_data(1)
	new victim = read_data(2)
	if (killer != victim && killer)	{
		new vorigin[3], korigin[3]
		get_user_origin(victim,vorigin)
		get_user_origin(killer,korigin)
		killers[victim][0] = killer
		killers[victim][1] = get_user_health(killer)
		killers[victim][2] = get_user_armor(killer)
		killers[victim][3] = get_distance(vorigin,korigin)
		if ( get_user_flags(0,STS_CHNL) & (1<<STS_FLAG7) ){
			new name[32], kmsg[128]
			get_user_name(killer,name,31)
			format(kmsg,127,"%s still has %dhp and %dap",name,killers[victim][1],killers[victim][2])
			client_print(victim,print_console,kmsg)
			set_hudmessage(255,255,255,0.02,0.9,2, 1.5, 3.0, 0.02, 5.0, 1)
			show_hudmessage(victim,kmsg)
		}
	}
}

public resethud_event(id) {
	if(klist[id]){
		new mode = get_user_flags(0,STS_CHNL)
		if ((mode&(STS_FLAG3))&&get_victims(id)){
			set_hudmessage(0,80,220,0.55,0.60,0, 6.0, 12.0, 1.0, 2.0, 4)
			show_hudmessage(id,buffor)
		}
		if ((mode&(STS_FLAG2))&&get_attackers(id)){
			set_hudmessage(220,80,0,0.55,0.35,0, 6.0, 12.0, 1.0, 2.0, 3)
			show_hudmessage(id,buffor)
		}
	}
	killers[id][0] = 0
	klist[id] = 1
}

public display_killer(id) {
	if ( !(get_user_flags(0,STS_CHNL) & (1<<STS_FLAG8)) ){
		client_print(id,print_chat,"* Server has disabled that option.")
		return PLUGIN_HANDLED
	}
	if (killers[id][0]) {
		new name[32], stats[8], body[8], wpn[33], mstats[8], mbody[8]
		get_user_name(killers[id][0],name,31)
		get_user_astats(id,killers[id][0],stats,body,wpn,31)
		get_user_vstats(id,killers[id][0],mstats,mbody)
		client_print(id,print_chat,"* %s killed you with %s from distance of %.2f meters",	name,wpn,float(killers[id][3]) * 0.0254 )
		client_print(id,print_chat,"* He did %d damage to you with %d hit(s) and still had %dhp and %dap",
			stats[6],stats[5], killers[id][1],killers[id][2] )
		client_print(id,print_chat,"* You did %d damage to him with %d hit(s)",mstats[6],	mstats[5] )
		if (get_myhits(id,killers[id][0])) client_print(id,print_chat,buffor)
	}
	else {
		client_print(id,print_chat,"* You have no killer...")
	}
	return PLUGIN_CONTINUE
}

public disp_stats(id){
	if ( !(get_user_flags(0,STS_CHNL) & (1<<STS_FLAG12)) ){
		client_print(id,print_chat,"* Server has disabled that option.")
		return PLUGIN_HANDLED
	}
	display_stats(id,id)
	return PLUGIN_CONTINUE
}

public display_stats(id,dest) {
	new name[32], stats[8], body[8]
	get_user_wstats(id,0,stats,body)
	new pos = format(buffor,2047,"Kills: %d^nDeaths: %d^nDamage: %d^nHits: %d^nShots: %d^n^n",
		stats[0],stats[1],stats[6],stats[5],stats[4])
	for(new a = 1; a < 31; ++a)	{
		if (get_user_wstats(id,a,stats,body)){
			get_weaponname(a,name,31)
			pos += format(buffor[pos],2047-pos,"%s shots: %d  hits: %d  damage: %d  kills: %d  deaths: %d^n",
				name[7],stats[4],stats[5],stats[6],stats[0],stats[1])
		}
	}
	get_user_name(id,name,31)
	show_motd(dest,buffor,name)
	return PLUGIN_CONTINUE
}

public disp_rank(id){
	if ( !(get_user_flags(0,STS_CHNL) & (1<<STS_FLAG11)) ){
		client_print(id,print_chat,"* Server has disabled that option.")
		return PLUGIN_HANDLED
	}
	display_rank(id,id)
	return PLUGIN_CONTINUE
}

public display_rank(id,dest) {
	new name[32], stats[8], body[8]
	new rank_pos = get_user_stats(id,stats,body)
	new pos = format(buffor,2047,"Kills: %d^nDeaths: %d^nDamage: %d^nHits: %d^nShots: %d^n^n",
		stats[0],stats[1],stats[6],stats[5],stats[4])
	pos += format(buffor[pos],2047-pos,"Hits:^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n^n",
		body_part[1],body[1],body_part[2],body[2],body_part[3],body[3],	body_part[4],body[4],
		body_part[5],body[5],body_part[6],body[6],body_part[7],body[7])
	format(buffor[pos],2047-pos,"%s rank is %d of %d",(id==dest)?"Your":"His", rank_pos,get_statsnum())
	get_user_name(id,name,31)
	show_motd(dest,buffor,name)
	return PLUGIN_CONTINUE
}

public display_top15(id) {
	if ( !(get_user_flags(0,STS_CHNL) & (1<<STS_FLAG10)) ){
		client_print(id,print_chat,"* Server has disabled that option.")
		return PLUGIN_HANDLED
	}
	get_top15()
	show_motd(id,buffor,"Top 15")
	return PLUGIN_CONTINUE
}

public end_game_stats(){
	new mode = get_user_flags(0,STS_CHNL)
	if ( mode & (1<<STS_FLAG5) ){
		new players[32], inum
		get_players(players,inum)
		for(new i = 0; i < inum; ++i)
			display_stats(players[i],players[i])
	}	
	else if ( mode & (1<<STS_FLAG6) )	{
		new players[32], inum
		get_players(players,inum)
		get_top15()
		for(new i = 0; i < inum; ++i)
			show_motd(players[i],buffor,"Top 15")
	}
}

public intermission_event()
	set_task(1.0,"end_game_stats")
	
public disp_pplstats(id){
	if ( !(get_user_flags(0,STS_CHNL) & (1<<STS_FLAG9)) ){
		client_print(id,print_chat,"* Server has disabled that option.")
		return PLUGIN_HANDLED
	}
	show_ppl_menu(id,user_position[id]=0)
	return PLUGIN_CONTINUE
}

public action_ppl_menu(id,key){
	switch(key){
	case 7: {
		user_state[id] = !user_state[id]
		show_ppl_menu(id,user_position[id])
	}
	case 8: show_ppl_menu(id,++user_position[id])
	case 9:	show_ppl_menu(id,--user_position[id])
	default:{
		new option = user_position[id] * 7 + key
		new index = user_players[id][option]
		if (is_user_connected(index)){
			if (user_state[id])
				display_rank(index,id)
			else
				display_stats(index,id)
		}
		show_ppl_menu(id,user_position[id])
		}
	}
	return PLUGIN_HANDLED
}

show_ppl_menu(id,pos){
	if (pos < 0) return PLUGIN_HANDLED
	new menu_body[512], inum, start = pos * 7
	get_players(user_players[id],inum)
	if (start >= inum) start = pos = user_position[id] = 0
	new len = format(menu_body,511,"\yAMX Stats\R%d/%d^n\w^n",pos + 1,((inum/7)+((inum%7)?1:0)))
	new name[32], end = start + 7, keys = (1<<9)|(1<<7)
	if (end > inum) end = inum
	pos = 0
	for(new a = start; a < end; ++a){
		get_user_name(user_players[id][a],name,31)
		keys |= (1<<pos)
		len += format(menu_body[len],511-len,"%d. %s^n\w",++pos,name)
	}
	len += format(menu_body[len],511-len,"^n8. %s^n\w",user_state[id] ? "Show rank" : "Show stats" )
	if (end != inum){
		len += format(menu_body[len],511-len,"^n9. More...^n0. Back")
		keys |= (1<<8)
	}
	else {
		len += format(menu_body[len],511-len,"^n0. Back")
	}
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public avmode(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	if (read_argc() < 2){
		new sflags[32]
		get_flags((get_user_flags(0,STS_CHNL)>>2),sflags,31)
		console_print(id,"^"amx_avlist_mode^" is ^"%s^"", sflags)
		return PLUGIN_HANDLED
	}
	new arg[32]
	read_argv(1,arg,31)
	remove_user_flags(0,0x1FFC,STS_CHNL)
	set_user_flags(0,(read_flags(arg)<<2),STS_CHNL)
	console_print(id,"^"amx_avlist_mode^" set to ^"%s^"", arg)
	return PLUGIN_HANDLED
}

public plugin_init() {
	register_plugin("Stats","0.9.3","default")
	register_event("Damage","damage_event","b","2!0","3=0","4!0")
	register_event("DeathMsg","deathmsg_event","a")
	register_event("ResetHUD","resethud_event","be")
	register_event("30","intermission_event","a")
	register_clcmd("say /hp","display_killer",0,"- displays info. about your killer")
	register_clcmd("say /statsme","disp_stats",0,"- displays your stats")
	register_clcmd("say /stats","disp_pplstats",0,"- displays others stats")
	register_clcmd("say /top15","display_top15",0,"- displays top 15 players")
	register_clcmd("say /rank","disp_rank",0,"- displays your server stats")
	register_srvcmd("amx_avlist_mode","avmode",ADMIN_CFG,"<flags> - sets stats options")
	register_menucmd(register_menuid("\yAMX Stats"),1023,"action_ppl_menu")
	server_cmd("amx_addoption ^"Show Attackers^" %d %d",STS_CHNL,STS_FLAG2)	
	server_cmd("amx_addoption ^"Show Victims^" %d %d",STS_CHNL,STS_FLAG3)	
	server_cmd("amx_addoption ^"Show killer^" %d %d",STS_CHNL,STS_FLAG4)
	server_cmd("amx_addoption ^"Stats at the end of map^" %d %d",STS_CHNL,STS_FLAG5)	
	server_cmd("amx_addoption ^"Top15 at the end of map^" %d %d",STS_CHNL,STS_FLAG6)	
	server_cmd("amx_addoption ^"Show killer hp&ap^" %d %d",STS_CHNL,STS_FLAG7)
	server_cmd("amx_addoption ^"Say /hp^" %d %d",STS_CHNL,STS_FLAG8)	
	server_cmd("amx_addoption ^"Say /stats^" %d %d",STS_CHNL,STS_FLAG9)	
	server_cmd("amx_addoption ^"Say /top15^" %d %d",STS_CHNL,STS_FLAG10)
	server_cmd("amx_addoption ^"Say /rank^" %d %d",STS_CHNL,STS_FLAG11)	
	server_cmd("amx_addoption ^"Say /statsme^" %d %d",STS_CHNL,STS_FLAG12)
	return PLUGIN_CONTINUE
}